#!/usr/bin/perl -w

#    This file is part of serialreader, an HTML reader for the iRex Iliad,
#    and is copyright (c) 2010 - 2012 Volker Schatz.
#
#    It is licensed under Version 3 or later of the Gnu General Public License
#    (see http://www.gnu.org/licenses/gpl.html for details).

use strict;

use Encode;

@ARGV == 1 or die "Need exactly one argument (the character encoding)";

my $enc= lc $ARGV[0];
my $codec= Encode::find_encoding($enc);
die "Encoding $enc not supported" unless $codec;

my $enclabel= $enc;
$enclabel =~ s/\W/_/g;

print <<EOF;
/* UTF-8 strings for code points of the following encoding from 128 to 255.
   Little-endian unsigned ints; use strncpy(dest, (char*)(tab+c-128), 4);  */
unsigned $enclabel\[]= {
EOF

for my $c (128 .. 255) {
    my $uni= reverse  Encode::encode_utf8 $codec->decode(pack "H*", sprintf("%x", $c));
    print "0x", unpack("H*", $uni), ", ";
}

print "};\n";

